import java.util.ArrayList;
import java.util.Arrays;
import javax.swing.DefaultComboBoxModel;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author addya
 */
public class SelectProducts extends javax.swing.JFrame {
    //arraylist of codes e.g. "01", "02", "03"...
    public ArrayList<String> codesArL= new ArrayList<String>();
    //array of products
    public String[] products = {"Pen", "Book", "Water", "Drink", "Snack", "Sweet", "Chocolate", "Biscuits", "Cake"};
    //array of prices
    public double[] prices = {1, 1, 1, 1, 2, 1, 1, 1, 2};
    //arraylist of amount of each item left in stock
    //its an arraylist so it can be initialised
    public ArrayList<Integer> stockArL = new ArrayList<Integer>();
    //array for the quantity of each item left
    public int[] stock;
    //temporary array for the quantity of each item left
    //this will update each time the user adds an item to their basket
    //after they checkout it will finalise and 
    public int[] tempStock;
    //index will be the position of the currently selected item in these arrays
    public int index;
    
    //the basket array must be an arraylist since we add new things to it dynamically using a button
    public ArrayList<String> basketArL= new ArrayList<String>();
    
    
    /**
     * Creates new form SelectProducts
     */
    public SelectProducts() {
        initComponents();
        
        //------------------Initialising stocks-------------------
        //this variable is how many iterations the loop performs
        //one iteration is done for eacah product
        int amountOfItems=products.length-1;
        
        for (int i=0;i<=amountOfItems;i++){
            String z="0";
            //if int i is below 10 then a "0" is added to the front
            //e.g. "01, "02", "03"
            //if int i is above or equal to 10 a "" (nothing) is added
            //e.g. "10", "11", "12"
            if (i>=10) {			
                z="";
            }
            else {
		z="0";
            }
            //String z (either "0" or "") is added to int i
            //after int i is converted to string
            String c =  z + Integer.toString(i);
            //String c is the code and added to the array of codes
            codesArL.add(c);
            //Each product starts off with a quantity of 20
            //so 20 is added to the stock arraylist
            stockArL.add(20);
        }
        
        Integer[] s = stockArL.toArray(new Integer[9]);
        int[] st = Arrays.stream(s).mapToInt(Integer::intValue).toArray();
        stock=st;
        tempStock=stock;
        
        //-----------------------------------------------
        //on the form starting the combobox cmbItems
        //is set to display the items in the products array
        DefaultComboBoxModel dm=new DefaultComboBoxModel(products);
        cmbProducts.setModel(dm);
        //the button to add items to basket is enabled at first
        //so the user can't add anything without selecting it
        btnAddItem.setEnabled(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        cmbProducts = new javax.swing.JComboBox<>();
        jScrollPane1 = new javax.swing.JScrollPane();
        txaShowSelected = new javax.swing.JTextArea();
        btnAddItem = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        txaBasket = new javax.swing.JTextArea();
        lblTotalCost = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        btnCheckout = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setBackground(new java.awt.Color(0, 0, 204));

        jPanel1.setBackground(new java.awt.Color(0, 0, 204));

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 36)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(255, 255, 0));
        jLabel1.setText("Select Products");

        cmbProducts.setBackground(new java.awt.Color(255, 255, 0));
        cmbProducts.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        cmbProducts.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmbProductsActionPerformed(evt);
            }
        });

        txaShowSelected.setEditable(false);
        txaShowSelected.setColumns(20);
        txaShowSelected.setFont(new java.awt.Font("Tahoma", 2, 14)); // NOI18N
        txaShowSelected.setRows(5);
        jScrollPane1.setViewportView(txaShowSelected);

        btnAddItem.setBackground(new java.awt.Color(255, 255, 0));
        btnAddItem.setText("Add Item");
        btnAddItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddItemActionPerformed(evt);
            }
        });

        txaBasket.setEditable(false);
        txaBasket.setColumns(20);
        txaBasket.setRows(5);
        jScrollPane2.setViewportView(txaBasket);

        lblTotalCost.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        lblTotalCost.setForeground(new java.awt.Color(255, 255, 0));
        lblTotalCost.setText("Total: £0.0");

        jLabel3.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        jLabel3.setForeground(new java.awt.Color(255, 255, 0));
        jLabel3.setText("Your Basket");

        btnCheckout.setBackground(new java.awt.Color(255, 255, 0));
        btnCheckout.setText("Checkout");
        btnCheckout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCheckoutActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(27, 27, 27)
                                .addComponent(cmbProducts, javax.swing.GroupLayout.PREFERRED_SIZE, 109, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 178, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(200, 200, 200)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(lblTotalCost, javax.swing.GroupLayout.PREFERRED_SIZE, 127, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addGap(10, 10, 10)
                                        .addComponent(btnCheckout))
                                    .addComponent(btnAddItem, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE))))
                        .addGap(18, 18, 18)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 178, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel1)))
                .addContainerGap(97, Short.MAX_VALUE))
            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                    .addContainerGap(381, Short.MAX_VALUE)
                    .addComponent(jLabel3)
                    .addGap(149, 149, 149)))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(20, 20, 20)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(cmbProducts, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(12, 12, 12)
                        .addComponent(btnAddItem, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(lblTotalCost, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnCheckout, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(12, 12, 12))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 192, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(31, Short.MAX_VALUE))
            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(jPanel1Layout.createSequentialGroup()
                    .addGap(63, 63, 63)
                    .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(219, Short.MAX_VALUE)))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void cmbProductsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmbProductsActionPerformed
        // TODO add your handling code here:
        btnAddItem.setEnabled(true);
        String display;
        String find=cmbProducts.getSelectedItem().toString();
        String current="";
        for (int i=0; i<products.length; i++){
            current=products[i];
            if (current==find){
                //index is equal to i
                //this is the position of the product we want to find
                index=i;
                if (tempStock[index]<=0){
                    display="Item: "+products[i]+"\nPrice: £"+prices[i]+"\nSorry, out of stock.";
                    btnAddItem.setEnabled(false);
                }
                else{
                    display="Item: "+products[i]+"\nPrice: £"+prices[i];
                }
                txaShowSelected.setText(display);
            }
            else {
            }
        }
    }//GEN-LAST:event_cmbProductsActionPerformed

    //the variable for the total cost must be defined outside of the action event
    //otherwise it would be reset to 0 each time the button was clicked
    double total=0;
    private void btnAddItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddItemActionPerformed
        // TODO add your handling code here:
        //when the 'Add Item' button is pressed, if there is enough stock left
        if (tempStock[index]>0){
            //take away 1 from the stock of the added item
            int ts=tempStock[index];
            ts=ts-1;
            tempStock[index]=ts;
            //the item in the display should go into the basket
            txaBasket.append(products[index]+"\t"+prices[index]+"\n");

            //we add the item to the arraylist for the basket too
            basketArL.add(products[index]);

            //we will add the price of the added item to the total cost
            total= total + prices[index];
            //then display it with the total label
            lblTotalCost.setText("Total: £"+total);
        }
        else {
            String display="Item: "+products[index]+"\nPrice: £"+prices[index]+"\nSorry, out of stock.";
            txaShowSelected.setText(display);
            btnAddItem.setEnabled(false);
        }
    }//GEN-LAST:event_btnAddItemActionPerformed

    private void btnCheckoutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCheckoutActionPerformed
        // TODO add your handling code here:
        //when they're ready to check out they click this button
        //to open the CheckOut JFrame form
        this.setVisible(false);
        String[] basketArr = new String[basketArL.size()];
        basketArr = basketArL.toArray(basketArr);

        //the total cost of the items and the array of items in the basket 
        //are both passed to the next jFrame form
        new CheckOut(total, basketArr, products, stock, tempStock).setVisible(true);
    }//GEN-LAST:event_btnCheckoutActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(SelectProducts.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(SelectProducts.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(SelectProducts.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(SelectProducts.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new SelectProducts().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddItem;
    private javax.swing.JButton btnCheckout;
    private javax.swing.JComboBox<String> cmbProducts;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel lblTotalCost;
    private javax.swing.JTextArea txaBasket;
    private javax.swing.JTextArea txaShowSelected;
    // End of variables declaration//GEN-END:variables
}
